#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <linux/fb.h>
#include <linux/omapfb.h>
#include <linux/ioctl.h>

#include <SDL/SDL.h>


static SDL_Surface *sdl_surf_screen;

int fd_fb0 = -1;


int main(int argc, char**argv) {
   (void)argc;
   (void)argv;

#if 0
   setenv("SDL_VIDEODRIVER",     "omapdss", 1);  // select notaz' Pandora SDL driver (causes crash in SDL_Init())
#endif

   setenv("SDL_OMAP_VSYNC",      "1", 1);

   fd_fb0 = open("/dev/fb0", O_RDWR);

   if(-1 != fd_fb0)
   {
      if(SDL_Init(SDL_INIT_VIDEO) >= 0)
      {
         //sdl_surf_screen = SDL_SetVideoMode(800, 480, 32, SDL_HWSURFACE | SDL_DOUBLEBUF);
         sdl_surf_screen = SDL_SetVideoMode(800, 480, 32, SDL_HWSURFACE);
         //sdl_surf_screen = SDL_SetVideoMode(800, 480, 32, 0);
         
         if(NULL != sdl_surf_screen)
         {
            printf("SDL_SetVideoMode() ok. w=%d h=%d pixels=0x%p pitch=%u\n",
                   sdl_surf_screen->w,
                   sdl_surf_screen->h,
                   sdl_surf_screen->pixels,
                   sdl_surf_screen->pitch
                   );
            
            {
               int i;
               
               for(i=0; i<(5 * 60); i++)
               {
                  printf(".");
                  SDL_Flip(sdl_surf_screen);

                  ioctl(fd_fb0, OMAPFB_WAITFORVSYNC);
               }
               printf("\n");
            }
            
            printf("ok, calling SDL_Quit()\n");
            
            SDL_Quit();
         }
         else
         {
            printf("SDL_SetVideoMode() failed.\n");
         }
      }
      else
      {
         printf("SDL_Init() failed.\n");
      }

      //close(fd_fb0);
   }
   else
   {
      /* Failed: open /dev/fb0 */
      printf("failed to open /dev/fb0\n");
   }

   return 0;
}
